"""
    A8 starter code written by David Johnson. All derived works must not
    be posted publicly.

    A8 assignment completed by Zhuyi(Ben) Bu
"""


# Fill in the required assignment functions below here.
def curve_scores(int_list):
    """
    Curve a int list. For example, if the highest score in the list is 80, then, add it 20 to it so it will become
    100. After that, add 20 to the rest elements of this list
    :param int_list: A int list representing scores that is going to be curved
    :return: A curved int list
    """

    new_list = []
    biggest_score = int_list[0]

    for index in range(1, len(int_list)):
        if int_list[index] > biggest_score:
            biggest_score = int_list[index]

    curve_amount = 100 - biggest_score;

    for index in range(len(int_list)):
        new_list.append(int_list[index] + curve_amount)

    return new_list;


def contains_duplicate(string_list):
    """
    This method helps find out if there is duplicated string in a string list

    :param string_list: a string list that is going to be checked
    :return: A boolean value that represent if the string list a duplicated value.
    """

    checked_string_dic = {}

    for index in range(len(string_list)):
        if not string_list[index] in checked_string_dic:
            checked_string_dic[string_list[index]] = 0
        else:
            return True

    return False


def list_to_string(int_list):
    """
    Convert a int list to a string list

    :param int_list: the int list that is going to be converted
    :return: A string list that contains the same elements from the int list
    """

    new_string = "["

    for index in range(len(int_list)):
        new_string += str(int_list[index])

        if index != len(int_list) - 1:
            new_string += ", "

    new_string += "]"
    return new_string


def find_smallest_positive_number(int_list):
    """
    This method can help find the smallest positive number in a int list

    :param int_list: The int list that is going to be iterated through
    :return: the smallest positive number in the int list
    """

    smallest_positive_int = None
    has_positive = False

    for index in range(len(int_list)):
        if int_list[index] > 0:
            smallest_positive_int = int_list[index]
            has_positive = True
            break

    if not has_positive:
        return None

    for index in range(len(int_list)):
        if int_list[index] > 0 and smallest_positive_int > int_list[index]:
            smallest_positive_int = int_list[index]

    return smallest_positive_int


def lines_from_file(path):
    """
    Convert the string content of a file to a string list

    :param path: the path representing where the file is stored in computer
    :return: the content of the file in a sting list form
    """

    return open(path).read().splitlines()


def binary_search_for_matching_string(key, target_list):
    """
    Using binary search to find the key value in the target list.

    :param key: The key that we want to find in a list
    :param target_list: The list that is going to be searched
    :return: If the key value exists in the list, return the value. Otherwise, return None
    """

    return binary_search_for_key(key, target_list)


def binary_search_for_key(key, values):
    """
    Return the location of key in the values list, or None if no match. This function uses
    binary search to efficiently search a sorted list.

    :param key: The item to search for
    :param values: A sorted list of values
    :return: The location of the matching item or None if no match.
    """
    lo = 0
    hi = len(values) - 1
    while lo <= hi:
        mid = lo + (hi - lo) // 2
        if values[mid].startswith(key):  # if key found return where it is
            return values[mid]
        elif values[mid] < key:  # If the checked value is less than key, remove left half of list
            lo = mid + 1
        else:  # If the checked value is greater than key, remove right half of list
            hi = mid - 1
    return None


def main():
    test_int_list1 = [40, 60, 75, 90]
    test_int_list2 = [10, 80, 30, 50]
    test_string_list1 = ["apple", "banana", "orange"]
    test_string_list2 = ["apple", "apple", "banana"]
    print("Test curve_scores for", test_int_list1, "The correct result should be [50, 70, 85, 100] and the result is",
          curve_scores(test_int_list1))
    print("Test curve_scores for", test_int_list2, "The correct result should be [30, 100, 50, 70] and the result is",
          curve_scores(test_int_list2))
    print("Test contain_duplicat for", test_string_list1, "The correct result should be False and the result is",
          contains_duplicate(test_string_list1))
    print("Test contain_duplicat for", test_string_list2, "The correct result should be True and the result is",
          contains_duplicate(test_string_list2))
    print("Test list_to_string for", test_int_list1, "The correct result should be [40, 60, 75, 90] and th result is",
          list_to_string(test_int_list1))
    print("Test list_to_string for", test_int_list2, "The correct result should be [10, 80, 30, 50] and th result is",
          list_to_string(test_int_list2))

    test_int_list3 = [-4, 5, -9, 2, 1]
    test_int_list4 = [-2, -5, -6]
    print("Test def find_smallest_positive_number for", test_int_list3,
          "The correct result should be 1 and the result is", find_smallest_positive_number(test_int_list3))
    print("Test def find_smallest_positive_number for", test_int_list4,
          "The correct result should be None and the result is", find_smallest_positive_number(test_int_list4))


if __name__ == "__main__":
    main()
